import PhoneNumberAuthRepo, { RepoHttpHandler } from '../data/repository/phonenumberAuthRepo';
import PhonenumberAuthUsecase from '../usecase/phonenumberAuthUsecase';

export interface IPhonenumberAuthInfra {
  httpHandler: RepoHttpHandler;
  wrongPhoneNumberMessage: string;
}

const phonenumberAuthInfra = async (
  httpHandler: RepoHttpHandler,
  wrongPhoneNumberMessage: string,
): Promise<PhonenumberAuthUsecase> => {
  // prepare repo
  const repository = new PhoneNumberAuthRepo(httpHandler);
  // prepare usecase
  const usecase = new PhonenumberAuthUsecase(repository, wrongPhoneNumberMessage);
  // return main method
  return usecase;
};

export default phonenumberAuthInfra;
